OGRE: Ogre::GL3PlusDepthBuffer Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Attributes | List of all members
Ogre::GL3PlusDepthBuffer Class Reference

More...

`#include <OgreGL3PlusDepthBuffer.h>`

Inheritance diagram for Ogre::GL3PlusDepthBuffer:
[legend]

## Public Types
enum | PoolId { POOL_NO_DEPTH = 0, POOL_MANUAL_USAGE = 0, POOL_DEFAULT = 1, POOL_NON_SHAREABLE = 65534, POOL_INVALID = 65535, POOL_NO_DEPTH = 0, POOL_MANUAL_USAGE = 0, POOL_DEFAULT = 1, POOL_NON_SHAREABLE = 65534, POOL_INVALID = 65535 }
enum | PoolId { POOL_NO_DEPTH = 0, POOL_MANUAL_USAGE = 0, POOL_DEFAULT = 1, POOL_NON_SHAREABLE = 65534, POOL_INVALID = 65535, POOL_NO_DEPTH = 0, POOL_MANUAL_USAGE = 0, POOL_DEFAULT = 1, POOL_NON_SHAREABLE = 65534, POOL_INVALID = 65535 }

## Public Member Functions
| GL3PlusDepthBuffer (uint16 poolId, GL3PlusRenderSystem *renderSystem, GL3PlusContext *creatorContext, GLenum depthFormat, GLenum stencilFormat, uint32 width, uint32 height, uint32 fsaa, uint32 multiSampleQuality, PixelFormat pixelFormat, bool isDepthTexture, bool _isManual)
| ~GL3PlusDepthBuffer ()
virtual void | _notifyRenderTargetAttached (RenderTarget *renderTarget)
| Called when a RenderTarget is attaches this DepthBuffer. More...
virtual void | _notifyRenderTargetDetached (RenderTarget *renderTarget)
| Called when a RenderTarget is detaches from this DepthBuffer. More...
void | _setPoolId (uint16 poolId)
| Sets the pool id in which this DepthBuffer lives. More...
void | bindToFramebuffer (GLenum target=GL_FRAMEBUFFER)
bool | copyTo (DepthBuffer *destination)
| Copies the contents of the DepthBuffer to the destination. More...
virtual uint16 | getBitDepth () const
GLuint | getDepthBuffer () const
PixelFormat | getFormat (void) const
virtual uint32 | getFsaa () const
virtual const String & | getFsaaHint () const
GL3PlusContext * | getGLContext () const
virtual uint32 | getHeight () const
virtual uint16 | getPoolId () const
| Gets the pool id in which this DepthBuffer lives. More...
GLuint | getStencilBuffer () const
virtual uint32 | getWidth () const
bool | hasSeparateStencilBuffer () const
virtual bool | isCompatible (RenderTarget *renderTarget, bool exactFormatMatch) const
| Returns whether the specified RenderTarget is compatible with this DepthBuffer That is, this DepthBuffer can be attached to that RenderTarget. More...
bool | isDepthTexture (void) const
bool | isManual () const
| Manual DepthBuffers are cleared in RenderSystem's destructor. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...

## Static Public Attributes
static PixelFormatGpu | DefaultDepthBufferFormat

## Detailed Description

OpenGL supports 3 different methods: FBO, pbuffer & Copy. Each one has it's own limitations. Non-FBO methods are solved using "dummy" DepthBuffers. That is, a DepthBuffer pointer is attached to the RenderTarget (for the sake of consistency) but it doesn't actually contain a Depth surface/renderbuffer (mDepthBuffer & mStencilBuffer are null pointers all the time) Those dummy DepthBuffers are identified thanks to their GL context. Note that FBOs don't allow sharing with the main window's depth buffer. Therefore even when FBO is enabled, a dummy DepthBuffer is still used to manage the windows.

## Member Enumeration Documentation

## ◆ PoolId [1/2]

enum Ogre::DepthBuffer::PoolId
| inherited

Enumerator
POOL_NO_DEPTH |
POOL_MANUAL_USAGE |
POOL_DEFAULT |
POOL_NON_SHAREABLE |
POOL_INVALID |
POOL_NO_DEPTH |
POOL_MANUAL_USAGE |
POOL_DEFAULT |
POOL_NON_SHAREABLE |
POOL_INVALID |

## ◆ PoolId [2/2]

enum Ogre::DepthBuffer::PoolId
| inherited

Enumerator
POOL_NO_DEPTH |
POOL_MANUAL_USAGE |
POOL_DEFAULT |
POOL_NON_SHAREABLE |
POOL_INVALID |
POOL_NO_DEPTH |
POOL_MANUAL_USAGE |
POOL_DEFAULT |
POOL_NON_SHAREABLE |
POOL_INVALID |

## Constructor & Destructor Documentation

## ◆ GL3PlusDepthBuffer()

Ogre::GL3PlusDepthBuffer::GL3PlusDepthBuffer | ( | uint16 | poolId,
|  | GL3PlusRenderSystem * | renderSystem,
|  | GL3PlusContext * | creatorContext,
|  | GLenum | depthFormat,
|  | GLenum | stencilFormat,
|  | uint32 | width,
|  | uint32 | height,
|  | uint32 | fsaa,
|  | uint32 | multiSampleQuality,
|  | PixelFormat | pixelFormat,
|  | bool | isDepthTexture,
|  | bool | _isManual
| ) |  |

## ◆ ~GL3PlusDepthBuffer()

Ogre::GL3PlusDepthBuffer::~GL3PlusDepthBuffer | ( |  | ) |

## Member Function Documentation

## ◆ _notifyRenderTargetAttached()

virtual void Ogre::DepthBuffer::_notifyRenderTargetAttached | ( | RenderTarget * | renderTarget | ) |
| virtualinherited

Called when a RenderTarget is attaches this DepthBuffer.

Remarks
  This function doesn't actually attach. It merely informs the DepthBuffer which RenderTarget did attach. The real attachment happens in RenderTarget::attachDepthBuffer()

Parameters

  renderTarget | The RenderTarget that has just been attached

## ◆ _notifyRenderTargetDetached()

virtual void Ogre::DepthBuffer::_notifyRenderTargetDetached | ( | RenderTarget * | renderTarget | ) |
| virtualinherited

Called when a RenderTarget is detaches from this DepthBuffer.

Remarks
  Same as DepthBuffer::_notifyRenderTargetAttached()

Parameters

  renderTarget | The RenderTarget that has just been detached

## ◆ _setPoolId()

void Ogre::DepthBuffer::_setPoolId | ( | uint16 | poolId | ) |
| inherited

Sets the pool id in which this DepthBuffer lives.

Note this will detach any render target from this depth buffer

## ◆ bindToFramebuffer()

void Ogre::GL3PlusDepthBuffer::bindToFramebuffer | ( | GLenum | target = `GL_FRAMEBUFFER` | ) |

## ◆ copyTo()

bool Ogre::DepthBuffer::copyTo | ( | DepthBuffer * | destination | ) |
| inherited

Copies the contents of the DepthBuffer to the destination.

Useful when you want to bind a DepthBuffer for sampling as a texture, but later resume rendering with this depth buffer (binding a DepthBuffer as a texture forces it to be decompressed and disables other optimization algorithms on a lot of Hardware. GCN Tahiti aka AMD Radeon R9 280 is no longer affected by this issue)

Remarks
  The function will throw if the depth buffers are incompatible (e.g. different resolution, different format, different MSAA settings)

Parameters

  destination | DepthBuffer to copy to.

Returns
  False if failed to copy for hardware reasons (DX10 does not allow copying MSAA depth buffer; DX10.1 does)

## ◆ getBitDepth()

virtual uint16 Ogre::DepthBuffer::getBitDepth | ( |  | ) | const
| virtualinherited

## ◆ getDepthBuffer()

GLuint Ogre::GL3PlusDepthBuffer::getDepthBuffer | ( |  | ) | const
| inline

## ◆ getFormat()

PixelFormat Ogre::DepthBuffer::getFormat | ( | void |  | ) | const
| inherited

## ◆ getFsaa()

virtual uint32 Ogre::DepthBuffer::getFsaa | ( |  | ) | const
| virtualinherited

## ◆ getFsaaHint()

virtual const String& Ogre::DepthBuffer::getFsaaHint | ( |  | ) | const
| virtualinherited

## ◆ getGLContext()

GL3PlusContext* Ogre::GL3PlusDepthBuffer::getGLContext | ( |  | ) | const
| inline

## ◆ getHeight()

virtual uint32 Ogre::DepthBuffer::getHeight | ( |  | ) | const
| virtualinherited

## ◆ getPoolId()

virtual uint16 Ogre::DepthBuffer::getPoolId | ( |  | ) | const
| virtualinherited

Gets the pool id in which this DepthBuffer lives.

## ◆ getStencilBuffer()

GLuint Ogre::GL3PlusDepthBuffer::getStencilBuffer | ( |  | ) | const
| inline

## ◆ getWidth()

virtual uint32 Ogre::DepthBuffer::getWidth | ( |  | ) | const
| virtualinherited

## ◆ hasSeparateStencilBuffer()

bool Ogre::GL3PlusDepthBuffer::hasSeparateStencilBuffer | ( |  | ) | const

## ◆ isCompatible()

virtual bool Ogre::GL3PlusDepthBuffer::isCompatible | ( | RenderTarget * | renderTarget,
|  | bool | exactFormatMatch
| ) |  | const
| virtual

Returns whether the specified RenderTarget is compatible with this DepthBuffer That is, this DepthBuffer can be attached to that RenderTarget.

Remarks
  Most APIs impose the following restrictions: Width & height must be equal or higher than the render target's They must be of the same bit depth. They need to have the same FSAA setting

Parameters

  renderTarget | The render target to test against
  exactFormatMatch | True if looking for the exact format according to the RT's preferred format. False if the RT's preferred format should be ignored.

Reimplemented from Ogre::DepthBuffer.

## ◆ isDepthTexture()

bool Ogre::DepthBuffer::isDepthTexture | ( | void |  | ) | const
| inherited

## ◆ isManual()

bool Ogre::DepthBuffer::isManual | ( |  | ) | const
| inherited

Manual DepthBuffers are cleared in RenderSystem's destructor.

Non-manual ones are released with it's render target (aka, a backbuffer or similar)

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## Member Data Documentation

## ◆ DefaultDepthBufferFormat

static PixelFormatGpu Ogre::DepthBuffer::DefaultDepthBufferFormat
| staticinherited

The documentation for this class was generated from the following file:

- OgreGL3PlusDepthBuffer.h